
#ifndef HH_TOP_HANDLER
#define HH_TOP_HANDLER

#include "async.hh"
#include "flow_handler.hh"
#include <string>

using namespace std;

class top_handler : private async, public flow_handler {
private:
    int fd;
    int conn_id;
    flow_handler *h;
    string buffer;
    int type;

    static info _info;

    // Never write again to application, e.g., application has called
    // shutdown(fd, SHUT_RD)
    bool shut_read;

    // Never read from application again, e.g., application has called
    // shutdown(fd, SHUT_WR)
    bool shut_write;

    bool closed;

    void check_shutdown();

public:
    top_handler(int _fd, int _type, int _conn_id, flow_handler *_h);
    virtual ~top_handler();
    virtual int close();

    int get_fd() { return fd; }
    int get_conn_id() { return conn_id; }
    flow_handler *get_handler() { return h; }

    void sigpipe();

    virtual void ravail();
    virtual void wavail();
    virtual void connected(flow_handler *from, bool success);
    virtual void accept_ready(flow_handler *from);
    string getsockopt(int level, int optname, int maxlen);
    int setsockopt(int level, int optname, string value);
    int ioctl(string target, int optname, string value, string& out);
    address getpeername();
    address getsockname();

    virtual bool avail(flow_handler *from, data d);
    virtual void may_write(flow_handler *from, bool may);
};

#endif
