#!/usr/bin/perl

use IO::Socket::INET;
use IO::Select;

my $port = shift || 8000;

sub do_syswrite
{
    my $sock = shift;
    my $val = shift;
    my $ptr = 0;
    while ($ptr < length($val)) {
	my $b = $sock->syswrite($val, length($val) - $ptr, $ptr);
	return if ($b <= 0);
	$ptr += $b;
    }
}

while (1) {
    my $sock = new IO::Socket::INET(Proto => "tcp",
				    PeerAddr => "localhost",
				    PeerPort => $port);
    die $! unless $sock;
    $sock->sockopt(77, "FOOBAR");
    print "getsockopt is @{[getsockopt($sock, 817, 1)]}\n";
    $sock->shutdown(1);

    my $stdin = new IO::Handle;
    $stdin->fdopen(fileno(STDIN), "r");

    my $sel = new IO::Select($stdin, $sock);

  SEL:
    while (my @ready = $sel->can_read) {
	foreach my $fh (@ready) {
	    if ($fh == $sock) {
		my $buf = "";
		my $bytes = $sock->sysread($buf, 1024);
		if (!defined($bytes) || $bytes == 0) {
		    last SEL;
		}
		$buf =~ s/[\n\r]//g;
		print "From server: \"$buf\"\n";
	    } else {
		# STDIN
		my $bytes = $fh->sysread($buf, 1024);
		$buf =~ s/[\n\r]//g;
		print "From stdin: \"$buf\"\n";
		last SEL if ($buf =~ /Q/);
		do_syswrite($sock, $buf);
	    }
	}
    }

    close $sock;
}
